#
# Please do not update/rebuild/touch this package before asking first
# to the KDE Team
# This package is part of the KDE Stack.
#

%define		oname		Falkon
%define		major		3
%define		libname		%mklibname %{name}private %{major}

%define rel 1

Name:		falkon
Summary:	Cross-platform Qt Web Browser based on QtWebEngine
Version: 23.04.1
Release:        %mkrel %{rel}
Group:		Networking/WWW
License:	GPLv3+ and BSD and LGPLv2+ and GPLv2+ and MPL
URL:		https://apps.kde.org/falkon/
Source0:	https://download.kde.org/stable/release-service/%{version}/src/%{name}-%{version}.tar.xz
# reenable native scrollbars by default (upstream disabled them in 2.1.2)
Patch0:		falkon-3.1.0-native-scrollbars.patch
BuildRequires:	kf5-rpm-macros
BuildRequires:	pkgconfig(Qt5Concurrent)
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5DBus)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Help)
BuildRequires:	pkgconfig(Qt5Network)
BuildRequires:	pkgconfig(Qt5Qml)
BuildRequires:	pkgconfig(Qt5QuickWidgets)
BuildRequires:	pkgconfig(Qt5Script)
BuildRequires:	pkgconfig(Qt5Sql)
BuildRequires:	pkgconfig(Qt5WebChannel)
BuildRequires:	pkgconfig(Qt5WebEngine)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	pkgconfig(Qt5X11Extras)
BuildRequires:	qttools5
BuildRequires:	dos2unix
BuildRequires:	pkgconfig(xcb-util)
BuildRequires:	pkgconfig(python3)

BuildRequires:	cmake(PySide2)
BuildRequires:	cmake(Shiboken2)

Requires:	%{name}-core	= %{version}-%{release}
Requires:	%{name}-plugins	= %{version}-%{release}

Obsoletes:	qupzilla < 2.2.5-2
Provides:	qupzilla = %{version}-%{release}

# forked version that uses D-Bus instead of lock files (see also #1551678)
Provides:	bundled(qtsingleapplication-qt5) 

%description
Falkon is a new KDE web browser, previously known as QupZilla.
Following this release, there will only be one last final QupZilla
release.

Falkon is a new and very fast QtWebEngine browser. It aims to be a lightweight
web browser available through all major platforms. This project has been
originally started only for educational purposes. But from its start, Falkon
has grown into a feature-rich browser.

Falkon has all standard functions you expect from a web browser. It includes
bookmarks, history (both also in sidebar) and tabs. Above that, you can manage
RSS feeds with an included RSS reader, block ads with a builtin AdBlock plugin,
block Flash content with Click2Flash and edit the local CA Certificates
database with an SSL Manager.

Falkon's main aim is to be a very fast and very stable QtWebEngine browser
available to everyone. There are already a lot of QtWebEngine browsers available,
but they are either bound to the KDE environment (rekonq), are not actively
developed or very unstable and miss important features. But there is missing
a multiplatform, modern and actively developed browser. Falkon is trying
to fill this gap by providing a very stable browsing experience.

If you were previously using QupZilla, you can manually migrate
your profiles to Falkon by moving the config directory (usually
in ~/.config/qupzilla/).
There is no automatic migration.

%package core
Summary:	%{oname} web browser core package
Group:		Networking/WWW
Provides:	webclient
Requires:	%{libname} = %{version}-%{release}
Requires:	qtbase5-database-plugin-sqlite
Requires:	qtwebengine5

Obsoletes:	qupzilla-core < 2.2.5-2
Provides:	qupzilla-core = %{version}-%{release}

%description core
Falkon is a new KDE web browser, previously known as QupZilla.
Following this release, there will only be one last final QupZilla
release.

Falkon is a new and very fast QtWebEngine browser. It aims to be a lightweight
web browser available through all major platforms. This project has been
originally started only for educational purposes. But from its start, Falkon
has grown into a feature-rich browser.

Falkon has all standard functions you expect from a web browser. It includes
bookmarks, history (both also in sidebar) and tabs. Above that, you can manage
RSS feeds with an included RSS reader, block ads with a builtin AdBlock plugin,
block Flash content with Click2Flash and edit the local CA Certificates
database with an SSL Manager.

Falkon's main aim is to be a very fast and very stable QtWebEngine browser
available to everyone. There are already a lot of QtWebEngine browsers available,
but they are either bound to the KDE environment (rekonq), are not actively
developed or very unstable and miss important features. But there is missing
a multiplatform, modern and actively developed browser. Falkon is trying
to fill this gap by providing a very stable browsing experience.

If you were previously using QupZilla, you can manually migrate
your profiles to Falkon by moving the config directory (usually
in ~/.config/qupzilla/).
There is no automatic migration.

%package plugins
Summary:	Various plugins for %{oname} web browser
Group:		Networking/WWW
Requires:	%{name}-core = %{version}

Obsoletes:	qupzilla-plugins < 2.2.5-2
Provides:	qupzilla-plugins = %{version}-%{release}

%description plugins
Falkon Plugins are dynamically loaded shared libraries (*.so) that can extend
application in almost any way. This package contains the following plugins:

* Mouse Gestures
* Access Keys Navigation
* Personal Information Manager
* GreaseMonkey

%package gnome-keyring
Summary:	GNOME keyring plugin for %{oname} web browser
Group:		Networking/WWW
BuildRequires:	pkgconfig(gnome-keyring-1)
Requires:	%{name}-core = %{version}-%{release}

Obsoletes:	qupzilla-gnome-keyring < 2.2.5-2
Provides:	qupzilla-gnome-keyring = %{version}-%{release}

%description gnome-keyring
Plugin for %{oname} web browser that allows to store passwords in
GNOME Keyring.

%package kde
Summary:	KDE Frameworks Integration plugin for %{oname} web browser
Group:		Networking/WWW
BuildRequires:	cmake(KF5Wallet)
BuildRequires:	cmake(KF5KIO)
BuildRequires:	cmake(KF5Crash)
BuildRequires:	cmake(KF5CoreAddons)
BuildRequires:	cmake(KF5Purpose)
Requires:	%{name}-core = %{version}-%{release}

Obsoletes:	qupzilla-kwallet < 2.2.5-2
Provides:	qupzilla-kwallet = %{version}-%{release}
Obsoletes:	falkon-kwallet < 3.1
Provides:	falkon-kwallet = %{version}-%{release} 

%description kde
Plugin for Falkon adding support for:

* storing passwords securely in KWallet,
* additional URL protocols using KIO (e.g., man:, info:, gopher:, etc.),
* a "Share page" menu using the KDE Purpose Framework,
* intercepting crashes with KCrash, bringing up the DrKonqi crash handler.

%package -n %{libname}
Summary:	%{oname} shared library
Group:		System/Libraries

Obsoletes:	%{_lib}qupzilla2 < 2.2.5-2
Obsoletes:	%{_lib}qupzilla-devel < 2.2.5-2

%description -n %{libname}
Shared library used by %{oname} web browser.

%prep
%setup -q
%autopatch -p1

dos2unix README.md

%build
%cmake_kf5
%cmake_build

%install
%cmake_install

%find_lang falkon_hellopython
%find_lang falkon_helloqml
%find_lang falkon_middleclickloader
%find_lang falkon_runaction
%find_lang_kf5 falkon_qt
%find_lang_kf5 falkon_autoscroll_qt
%find_lang_kf5 falkon_flashcookiemanager_qt
%find_lang_kf5 falkon_gnomekeyringpasswords_qt
%find_lang_kf5 falkon_greasemonkey_qt
%find_lang_kf5 falkon_kdeframeworksintegration_qt
%find_lang_kf5 falkon_kwalletpasswords_qt
%find_lang_kf5 falkon_mousegestures_qt
%find_lang_kf5 falkon_pim_qt
%find_lang_kf5 falkon_statusbaricons_qt
%find_lang_kf5 falkon_tabmanager_qt
%find_lang_kf5 falkon_testplugin_qt
%find_lang_kf5 falkon_verticaltabs_qt
cat *_qt.lang falkon_hellopython.lang falkon_helloqml.lang \
falkon_middleclickloader.lang falkon_runaction.lang > %{name}.lang

%files

%files core -f %{name}.lang
%doc CHANGELOG README.md
%license COPYING
%{_bindir}/%{name}
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/themes
%{_iconsdir}/hicolor/*/apps/*.png
%{_iconsdir}/hicolor/*/apps/*.svg
%{_datadir}/applications/org.kde.%{name}.desktop
%{_datadir}/bash-completion/completions/%{name}
%{_datadir}/metainfo/org.kde.%{name}.appdata.xml
%dir %{_qt5_plugindir}/%{name}

%files plugins
%{_qt5_plugindir}/%{name}/AutoScroll.so
%{_qt5_plugindir}/%{name}/FlashCookieManager.so
%{_qt5_plugindir}/%{name}/GreaseMonkey.so
%{_qt5_plugindir}/%{name}/MouseGestures.so
%{_qt5_plugindir}/%{name}/PIM.so
%{_qt5_plugindir}/%{name}/PyFalkon.so
%{_qt5_plugindir}/%{name}/StatusBarIcons.so
%{_qt5_plugindir}/%{name}/TabManager.so
%{_qt5_plugindir}/%{name}/VerticalTabs.so
%{_qt5_plugindir}/%{name}/middleclickloader/
%{_qt5_plugindir}/%{name}/runaction/

%files gnome-keyring
%{_qt5_plugindir}/%{name}/GnomeKeyringPasswords.so

%files kde
%{_qt5_plugindir}/%{name}/KDEFrameworksIntegration.so

%files -n %{libname}
%{_libdir}/libFalkonPrivate.so.%{major}{,.*}
%{_libdir}/libFalkonPrivate.so.23{,.*}


%changelog
* Mon May 29 2023 neoclust <neoclust> 23.04.1-1.mga9
+ Revision: 1959600
- New version 23.04.1

* Thu Mar 02 2023 neoclust <neoclust> 22.12.3-1.mga9
+ Revision: 1946422
- New version 22.12.3

* Tue Feb 14 2023 neoclust <neoclust> 22.12.2-1.mga9
+ Revision: 1941712
- New version 22.12.2

* Thu Dec 15 2022 neoclust <neoclust> 22.12.0-1.mga9
+ Revision: 1922835
- New version 22.12.0

* Wed Nov 30 2022 daviddavid <daviddavid> 22.11.90-2.mga9
+ Revision: 1913330
- add Shiboken2 and PySide2 support

* Sat Nov 26 2022 neoclust <neoclust> 22.11.90-1.mga9
+ Revision: 1911326
- New version 22.11.90

* Thu Nov 10 2022 neoclust <neoclust> 22.08.3-1.mga9
+ Revision: 1905182
- New version 22.08.3

* Sun Sep 11 2022 neoclust <neoclust> 22.08.1-1.mga9
+ Revision: 1886901
- New version 22.08.1

* Mon Aug 29 2022 neoclust <neoclust> 22.08.0-1.mga9
+ Revision: 1881817
- New version 22.08.0

* Sat Apr 23 2022 neoclust <neoclust> 22.03.90-1.mga9
+ Revision: 1852891
- New version 22.03.90

* Wed Feb 02 2022 neoclust <neoclust> 3.2.0-1.mga9
+ Revision: 1770973
- New version 3.2.0

* Sat Oct 02 2021 wally <wally> 3.1.0-7.mga9
+ Revision: 1747483
- rebuild for openssl 3.0.0

* Wed Dec 16 2020 umeabot <umeabot> 3.1.0-6.mga8
+ Revision: 1658387
- Rebuild for new Qt5

* Tue Jul 14 2020 daviddavid <daviddavid> 3.1.0-5.mga8
+ Revision: 1605856
- add upstream patch to fix build with Qt 5.15

* Thu May 28 2020 daviddavid <daviddavid> 3.1.0-4.mga8
+ Revision: 1588464
- switch appdata file to kf5_metainfo dir

* Sat Feb 15 2020 daviddavid <daviddavid> 3.1.0-3.mga8
+ Revision: 1525867
- add upstream patch to fix build with Qt 5.14
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Sat Mar 30 2019 umeabot <umeabot> 3.1.0-2.mga7
+ Revision: 1381645
- Qt5 Rebuild

* Sat Mar 23 2019 daviddavid <daviddavid> 3.1.0-1.mga7
+ Revision: 1379669
- new version 3.1.0
- drop system-qtsingleapplication patch, Falkon's copy now uses D-Bus (#1551678)
- rebase native-scrollbars patch
- rename falkon-kwallet subpackage to falkon-kde

* Fri Feb 22 2019 daviddavid <daviddavid> 3.0.1-4.mga7
+ Revision: 1369350
- fix dangling link (mga#23576)

* Wed Jan 02 2019 daviddavid <daviddavid> 3.0.1-3.mga7
+ Revision: 1348636
- rebuild against new Qt5 5.12.0 stack

* Sun Sep 23 2018 umeabot <umeabot> 3.0.1-2.mga7
+ Revision: 1297660
- Mageia 7 Mass Rebuild

* Thu May 10 2018 daviddavid <daviddavid> 3.0.1-1.mga7
+ Revision: 1227992
- new version: 3.0.1
- rename and rediff system-qtsingleapplication patch

* Wed Mar 14 2018 daviddavid <daviddavid> 3.0.0-2.mga7
+ Revision: 1209251
- use find_lang_kf5 macro for translation files install

* Mon Mar 05 2018 daviddavid <daviddavid> 3.0.0-1.mga7
+ Revision: 1206645
- new version: 3.0.0 (qupzilla now renamed to falkon)
- switch to cmake
- update Source URL
- update description and summary
- move to new upstream name on falkon

* Mon Jan 29 2018 daviddavid <daviddavid> 2.2.5-1.mga7
+ Revision: 1198018
- new version: 2.2.5

* Mon Jan 22 2018 daviddavid <daviddavid> 2.2.4-1.mga7
+ Revision: 1195774
- new version: 2.2.4

* Tue Dec 26 2017 daviddavid <daviddavid> 2.2.3-1.mga7
+ Revision: 1185272
- new version: 2.2.3

* Tue Nov 07 2017 daviddavid <daviddavid> 2.2.1-1.mga7
+ Revision: 1176417
- new version: 2.2.1

* Sun Oct 29 2017 daviddavid <daviddavid> 2.2.0-1.mga7
+ Revision: 1174628
- new version: 2.2.0
- rebase native-scrollbars patch
- remove merged upstream patch

* Sun Aug 27 2017 daviddavid <daviddavid> 2.1.2-2.mga7
+ Revision: 1148306
- fix FTBFS with OpenSSL 1.1 (patch by Bernhard Rosenkränzer (bero))
- reenable native scrollbars by default (upstream disabled them in 2.1.2)

* Tue Jul 25 2017 daviddavid <daviddavid> 2.1.2-1.mga7
+ Revision: 1130792
- new version: 2.1.2

* Sun Oct 30 2016 daviddavid <daviddavid> 2.0.2-1.mga6
+ Revision: 1064158
- new version: 2.0.2

* Mon Sep 05 2016 daviddavid <daviddavid> 2.0.1-3.mga6
+ Revision: 1050124
- do not build on armv5tl because of missing qtwebengine5
- rename main library and devel subpackage (QupZilla to qupzilla)
- update summary and description

* Fri Aug 05 2016 daviddavid <daviddavid> 2.0.1-2.mga6
+ Revision: 1044651
- move qt5-database-plugin-sqlite and qtwebengine5 dependencies into the -core subpackage

* Tue Jun 14 2016 daviddavid <daviddavid> 2.0.1-1.mga6
+ Revision: 1021430
- new version: 2.0.1

* Mon Apr 25 2016 daviddavid <daviddavid> 2.0.0-3.mga6
+ Revision: 1006046
- add missing requires on qtwebengine5 to fix startup (fixes mga#18097)

* Sun Apr 24 2016 daviddavid <daviddavid> 2.0.0-2.mga6
+ Revision: 1005855
- new version: 2.0.0 (QtWebEngine upstream switch)
- now libmajor is 2
- remove unused BR pkgconfig(hunspell) (not used since the QtWebEngine switch)
- unbundle qtsingleapplication
- improve lang files installation
- enable kwallet plugin support
- enable gnome-keyring plugin support

* Thu Apr 21 2016 tv <tv> 1.8.9-3.mga6
+ Revision: 1004200
- rebuid for libhunspell 1.4

* Tue Feb 16 2016 umeabot <umeabot> 1.8.9-2.mga6
+ Revision: 962695
- Mageia 6 Mass Rebuild

* Sat Nov 14 2015 dglent <dglent> 1.8.9-1.mga6
+ Revision: 903081
- Version 1.8.9
- Spellcheck support (build with hunspell)

* Sat Nov 07 2015 daviddavid <daviddavid> 1.8.8-1.mga6
+ Revision: 898450
- new version: 1.8.8
- remove no more needed qtwebkit patch

* Sat Nov 07 2015 daviddavid <daviddavid> 1.8.7-1.mga6
+ Revision: 898397
- add patch from Fedora to fix build:
  * workaround qtwebkit-5.5.1 dropping QTWEBKIT_VERSION_CHECK macro (#1270602)
- fix Group
- add new locale files (da_DK and lt)
+ tv <tv>
- drop merged patch
- new release

* Mon Aug 10 2015 daviddavid <daviddavid> 1.8.6-2.mga6
+ Revision: 862359
- add upstream patch0 to fix build with Qt 5.5
  * https://github.com/QupZilla/qupzilla/commit/739e01796a3587c21e7496b43a5a3cdb3fb6d7c5

* Sat Mar 07 2015 luigiwalser <luigiwalser> 1.8.6-1.mga5
+ Revision: 817957
- 1.8.6 (mga#14842 and mga#15409)

* Wed Nov 19 2014 doktor5000 <doktor5000> 1.8.3-2.mga5
+ Revision: 797896
- bump release to move from updates_testing to release

* Wed Nov 19 2014 doktor5000 <doktor5000> 1.8.3-1.mga5
+ Revision: 797891
- add missing BuildRequire on pkgconfig(Qt5DBus)
- add missing BuildRequire on qttools5 for lrelease
- added missing BuildRequires on pkgconfig(Qt5Script)
- added missing BuildRequires on pkgconfig(Qt5Concurrent)
- added missing BuildRequires on qt5gui-private-devel
- removed old Requires on qt4-database-plugin-sqlite
- added Requires on qtbase5-database-plugin-sqlite
- use %%qmake_qt5 for QT5 build
- new version 1.8.3
  o added URL to github release for automatic download
- switch to QT5 build
- add BuildRequires on pkgconfig(Qt5WebKitWidgets)
- updated %%{lang} list due to missing detection for QT .qm files
- added appdata.xml file

* Wed Oct 15 2014 umeabot <umeabot> 1.6.6-3.mga5
+ Revision: 741519
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.6.6-2.mga5
+ Revision: 688587
- Mageia 5 Mass Rebuild

* Sun Jun 08 2014 matteo <matteo> 1.6.6-1.mga5
+ Revision: 634774
- new version

* Sun Mar 02 2014 matteo <matteo> 1.6.3-1.mga5
+ Revision: 598479
- new stable version

* Mon Oct 21 2013 umeabot <umeabot> 1.4.4-2.mga4
+ Revision: 538459
- Mageia 4 Mass Rebuild

* Mon Sep 30 2013 matteo <matteo> 1.4.4-1.mga4
+ Revision: 489732
- new version 1.4.4

* Thu Sep 12 2013 matteo <matteo> 1.4.3-3.mga4
+ Revision: 477813
- fixed qupzilla-plugins requirement (switched from qupzilla to qupzilla-core)
- fixed license definition

* Sun Sep 01 2013 matteo <matteo> 1.4.3-2.mga4
+ Revision: 473784
- fixed bad locale definitions into the spec file (see also bug mga#10572)

* Sat Jun 22 2013 matteo <matteo> 1.4.3-1.mga4
+ Revision: 445599
- new version (1.4.3)

* Wed May 29 2013 matteo <matteo> 1.4.1-2.mga4
+ Revision: 432773
- added missing br (bug mga#10319)

* Sun Apr 07 2013 matteo <matteo> 1.4.1-1.mga3
+ Revision: 408986
- dropped old patch
- new version
- fixed qupzilla-core shared library requirement
- fix bug mga#9584

* Sun Jan 13 2013 umeabot <umeabot> 1.3.5-2.mga3
+ Revision: 380124
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Fri Jan 04 2013 matteo <matteo> 1.3.5-1.mga3
+ Revision: 338428
- synced source
- removed wrong condition
- spec file reviewed
- Imported Mandriva package

